public class Garage {
    public static final int PARKING_SPOTS = 100;
    private Car[] parkingLot;
    private int size;

    // Constructs a new, empty set with the given underlying capacity
    public Garage() {
        parkingLot = new Car[PARKING_SPOTS];
        size = 0;
    }
    
    // Returns true if this set contains the specified car and false otherwise
    public boolean contains(Car car) {
        int index = car.hashCode() % PARKING_SPOTS;
        return parkingLot[index] != null;
    }

    // Adds the specified car to this garage if it is not already present.
    // Returns true if the car was not already present and false otherwise
    public boolean add(Car car) {
        if (contains(car)) {
            return false;
        }
        int index = car.hashCode() % PARKING_SPOTS;
        parkingLot[index] = car;
        size++;
        return true;
    }

    // Removes the specified car from this garage if it is present.
    // Returns true if the car was present and false otherwise
    public boolean remove(Car car) {
        if (!contains(car)) {
            return false;
        }
        int index = car.hashCode() % PARKING_SPOTS;
        parkingLot[index] = null;
        size--;
        return true;
    }

    // Returns the number of car in this garage
    public int size() {
        return this.size;
    }

    // Returns true if this garage has no cars
    public boolean isEmpty() {
        return this.size == 0;
    }
}
